<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>XsVector Class Reference</title>
<link href="xsens.css" rel="stylesheet" type="text/css"/>
</head><body>
<img class="logo" src="xsenslogo.jpg" alt="Xsens Logo" />
	<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="#related">Related Functions</a> &#124;
<a href="class_xs_vector-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">XsVector Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A class that represents a vector of real numbers.  
 <a href="struct_xs_vector.html#details">More...</a></p>
<div class="dynheader">
Inheritance diagram for XsVector:</div>
<div class="dyncontent">
<div class="center"><img src="struct_xs_vector__inherit__graph.png" border="0" usemap="#_xs_vector_inherit__map" alt="Inheritance graph"/></div>
<map name="_xs_vector_inherit__map" id="_xs_vector_inherit__map">
<area shape="rect" id="node2" href="struct_xs_vector3.html" title="A class that represents a fixed size (3) vector. " alt="" coords="5,80,85,107"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a498096071bf9c8cb4add00d3fcd51adc"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a498096071bf9c8cb4add00d3fcd51adc"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a498096071bf9c8cb4add00d3fcd51adc">XsVector</a> (XsSize sz=0, const XsReal *src=0)</td></tr>
<tr class="memdesc:a498096071bf9c8cb4add00d3fcd51adc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize a vector, empty or using the data in the supplied <em>sz</em> and <em>src</em>. <br /></td></tr>
<tr class="separator:a498096071bf9c8cb4add00d3fcd51adc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae97d0a58fb4cdbc1c66cd6d1829933dd"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae97d0a58fb4cdbc1c66cd6d1829933dd"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#ae97d0a58fb4cdbc1c66cd6d1829933dd">XsVector</a> (const <a class="el" href="struct_xs_vector.html">XsVector</a> &amp;other)</td></tr>
<tr class="memdesc:ae97d0a58fb4cdbc1c66cd6d1829933dd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize a vector using the supplied <em>other</em> vector. <br /></td></tr>
<tr class="separator:ae97d0a58fb4cdbc1c66cd6d1829933dd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac7a879958cbd4afb679fbef25042cb87"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac7a879958cbd4afb679fbef25042cb87"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#ac7a879958cbd4afb679fbef25042cb87">XsVector</a> (XsReal *ref, XsSize sz, <a class="el" href="group__enums.html#ga85bc9120949890bf9df4572ee9a95be5">XsDataFlags</a> flags_=<a class="el" href="group__enums.html#gga85bc9120949890bf9df4572ee9a95be5a31564d1db71bd760d05e87f90f7bdb8c">XSDF_None</a>)</td></tr>
<tr class="memdesc:ac7a879958cbd4afb679fbef25042cb87"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize a vector that references the supplied data. <br /></td></tr>
<tr class="separator:ac7a879958cbd4afb679fbef25042cb87"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a33b2989b338e5f14b5dc70a6c6dfac9b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a33b2989b338e5f14b5dc70a6c6dfac9b"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a33b2989b338e5f14b5dc70a6c6dfac9b">XsVector</a> (const <a class="el" href="struct_xs_vector.html">XsVector</a> &amp;other, XsReal *ref, XsSize sz, <a class="el" href="group__enums.html#ga85bc9120949890bf9df4572ee9a95be5">XsDataFlags</a> flags_=<a class="el" href="group__enums.html#gga85bc9120949890bf9df4572ee9a95be5a31564d1db71bd760d05e87f90f7bdb8c">XSDF_None</a>)</td></tr>
<tr class="memdesc:a33b2989b338e5f14b5dc70a6c6dfac9b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize a vector that references the supplied data. <br /></td></tr>
<tr class="separator:a33b2989b338e5f14b5dc70a6c6dfac9b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1940a6cfb6a3da48b97a655e81b3152a"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a1940a6cfb6a3da48b97a655e81b3152a">XsVector</a> (const <a class="el" href="struct_xs_quaternion.html">XsQuaternion</a> &amp;quat, XsReal deltaT)</td></tr>
<tr class="memdesc:a1940a6cfb6a3da48b97a655e81b3152a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get an effective angular velocity from the quaternion, which must represent a delta angle.  <a href="#a1940a6cfb6a3da48b97a655e81b3152a">More...</a><br /></td></tr>
<tr class="separator:a1940a6cfb6a3da48b97a655e81b3152a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adced7976779acc04274f9c175d6eaa23"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="adced7976779acc04274f9c175d6eaa23"></a>
<a class="el" href="struct_xs_vector.html">XsVector</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#adced7976779acc04274f9c175d6eaa23">operator=</a> (const <a class="el" href="struct_xs_vector.html">XsVector</a> &amp;other)</td></tr>
<tr class="memdesc:adced7976779acc04274f9c175d6eaa23"><td class="mdescLeft">&#160;</td><td class="mdescRight">Assignment operator. Copies from <em>other</em> into this. <br /></td></tr>
<tr class="separator:adced7976779acc04274f9c175d6eaa23"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a08ed04b76bcceebc3c2316cf8910cf39"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a08ed04b76bcceebc3c2316cf8910cf39">~XsVector</a> ()</td></tr>
<tr class="memdesc:a08ed04b76bcceebc3c2316cf8910cf39"><td class="mdescLeft">&#160;</td><td class="mdescRight">Release and clear the contents of the vector.  <a href="#a08ed04b76bcceebc3c2316cf8910cf39">More...</a><br /></td></tr>
<tr class="separator:a08ed04b76bcceebc3c2316cf8910cf39"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5beb327e40afab8412451c8273cb256c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a5beb327e40afab8412451c8273cb256c">assign</a> (XsSize sz, const XsReal *src)</td></tr>
<tr class="memdesc:a5beb327e40afab8412451c8273cb256c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize the <a class="el" href="struct_xs_vector.html" title="A class that represents a vector of real numbers. ">XsVector</a> using <em>sz</em> number of items from <em>src</em>.  <a href="#a5beb327e40afab8412451c8273cb256c">More...</a><br /></td></tr>
<tr class="separator:a5beb327e40afab8412451c8273cb256c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac8917f40e072ad07e31c149986ea9a8d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#ac8917f40e072ad07e31c149986ea9a8d">setSize</a> (XsSize sz)</td></tr>
<tr class="memdesc:ac8917f40e072ad07e31c149986ea9a8d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the size of the <a class="el" href="struct_xs_vector.html" title="A class that represents a vector of real numbers. ">XsVector</a> to <em>sz</em> items.  <a href="#ac8917f40e072ad07e31c149986ea9a8d">More...</a><br /></td></tr>
<tr class="separator:ac8917f40e072ad07e31c149986ea9a8d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaabbbc34e9a84f0f923de05ebd2565e5"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aaabbbc34e9a84f0f923de05ebd2565e5"></a>
XsSize&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#aaabbbc34e9a84f0f923de05ebd2565e5">size</a> () const </td></tr>
<tr class="memdesc:aaabbbc34e9a84f0f923de05ebd2565e5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the number of elements in the vector. <br /></td></tr>
<tr class="separator:aaabbbc34e9a84f0f923de05ebd2565e5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a772adda0d758bf01911d79333a9e8e9a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a772adda0d758bf01911d79333a9e8e9a"></a>
const XsReal *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a772adda0d758bf01911d79333a9e8e9a">data</a> () const </td></tr>
<tr class="memdesc:a772adda0d758bf01911d79333a9e8e9a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return a const pointer to the data. <br /></td></tr>
<tr class="separator:a772adda0d758bf01911d79333a9e8e9a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aef5de4d70cf544c155c3eda9fb304ad8"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aef5de4d70cf544c155c3eda9fb304ad8"></a>
<a class="el" href="struct_xs_vector.html">XsVector</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#aef5de4d70cf544c155c3eda9fb304ad8">operator*</a> (XsReal scalar) const </td></tr>
<tr class="memdesc:aef5de4d70cf544c155c3eda9fb304ad8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Multiply the vector by <em>scalar</em> and return the result. <br /></td></tr>
<tr class="separator:aef5de4d70cf544c155c3eda9fb304ad8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa6ac5ea98c4b78d70d6464e9e1b3bab5"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa6ac5ea98c4b78d70d6464e9e1b3bab5"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#aa6ac5ea98c4b78d70d6464e9e1b3bab5">operator*=</a> (XsReal scalar)</td></tr>
<tr class="memdesc:aa6ac5ea98c4b78d70d6464e9e1b3bab5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Multiply the vector by <em>scalar</em> and store the result in this vector. <br /></td></tr>
<tr class="separator:aa6ac5ea98c4b78d70d6464e9e1b3bab5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a862f31efd08b4a6afb076ad9f205ceb0"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a862f31efd08b4a6afb076ad9f205ceb0"></a>
XsReal &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a862f31efd08b4a6afb076ad9f205ceb0">at</a> (XsSize index)</td></tr>
<tr class="memdesc:a862f31efd08b4a6afb076ad9f205ceb0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a reference to the <em>index'th</em> item in the vector. <br /></td></tr>
<tr class="separator:a862f31efd08b4a6afb076ad9f205ceb0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab62f45bc6da75d4fb6a067f142876dbc"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab62f45bc6da75d4fb6a067f142876dbc"></a>
const XsReal &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#ab62f45bc6da75d4fb6a067f142876dbc">at</a> (XsSize index) const </td></tr>
<tr class="memdesc:ab62f45bc6da75d4fb6a067f142876dbc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a const reference to the <em>index'th</em> item in the vector. <br /></td></tr>
<tr class="separator:ab62f45bc6da75d4fb6a067f142876dbc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a79106a9af236f142bf3d32f387ddc373"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a79106a9af236f142bf3d32f387ddc373"></a>
XsReal&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a79106a9af236f142bf3d32f387ddc373">value</a> (XsSize index) const </td></tr>
<tr class="memdesc:a79106a9af236f142bf3d32f387ddc373"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the <em>index'th</em> item in the vector. <br /></td></tr>
<tr class="separator:a79106a9af236f142bf3d32f387ddc373"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1dfb4f7e57798e0bac30af2d49bd044c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1dfb4f7e57798e0bac30af2d49bd044c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a1dfb4f7e57798e0bac30af2d49bd044c">setValue</a> (XsSize index, XsReal val)</td></tr>
<tr class="memdesc:a1dfb4f7e57798e0bac30af2d49bd044c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the <em>index'th</em> item in the vector. <br /></td></tr>
<tr class="separator:a1dfb4f7e57798e0bac30af2d49bd044c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a612acd51a2a14c5f2405abc902c55d3e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a612acd51a2a14c5f2405abc902c55d3e"></a>
XsReal&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a612acd51a2a14c5f2405abc902c55d3e">operator[]</a> (XsSize index) const </td></tr>
<tr class="memdesc:a612acd51a2a14c5f2405abc902c55d3e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the <em>index'th</em> item in the vector. <br /></td></tr>
<tr class="separator:a612acd51a2a14c5f2405abc902c55d3e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a72d18c63de099e5b135d7010f000fedc"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a72d18c63de099e5b135d7010f000fedc"></a>
XsReal &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a72d18c63de099e5b135d7010f000fedc">operator[]</a> (XsSize index)</td></tr>
<tr class="memdesc:a72d18c63de099e5b135d7010f000fedc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a reference the <em>index'th</em> item in the vector. <br /></td></tr>
<tr class="separator:a72d18c63de099e5b135d7010f000fedc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aede783e5d42510ca900fedb03785c5cc"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aede783e5d42510ca900fedb03785c5cc"></a>
XsReal&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#aede783e5d42510ca900fedb03785c5cc">dotProduct</a> (const <a class="el" href="struct_xs_vector.html">XsVector</a> &amp;v) const </td></tr>
<tr class="memdesc:aede783e5d42510ca900fedb03785c5cc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute and return the dot product of XsVectors <em>a</em> and <em>b</em>. <br /></td></tr>
<tr class="separator:aede783e5d42510ca900fedb03785c5cc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8d233a95a950bc1decf33fc05cc36438"><td class="memItemLeft" align="right" valign="top">XsReal&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a8d233a95a950bc1decf33fc05cc36438">cartesianLength</a> () const </td></tr>
<tr class="memdesc:a8d233a95a950bc1decf33fc05cc36438"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute and return the cartesian length.  <a href="#a8d233a95a950bc1decf33fc05cc36438">More...</a><br /></td></tr>
<tr class="separator:a8d233a95a950bc1decf33fc05cc36438"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a71be6087010ff667bead275af69c2125"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a71be6087010ff667bead275af69c2125">normalize</a> ()</td></tr>
<tr class="memdesc:a71be6087010ff667bead275af69c2125"><td class="mdescLeft">&#160;</td><td class="mdescRight">Normalize the vector.  <a href="#a71be6087010ff667bead275af69c2125">More...</a><br /></td></tr>
<tr class="separator:a71be6087010ff667bead275af69c2125"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a13ca733dfc284835822cac75e1c05307"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a13ca733dfc284835822cac75e1c05307"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a13ca733dfc284835822cac75e1c05307">setZero</a> ()</td></tr>
<tr class="memdesc:a13ca733dfc284835822cac75e1c05307"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets all elements of the XsVector to 0. <br /></td></tr>
<tr class="separator:a13ca733dfc284835822cac75e1c05307"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afb1b4fbc07163a7b5fc52e795a2e0fa7"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="afb1b4fbc07163a7b5fc52e795a2e0fa7"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#afb1b4fbc07163a7b5fc52e795a2e0fa7">empty</a> () const </td></tr>
<tr class="memdesc:afb1b4fbc07163a7b5fc52e795a2e0fa7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a non-zero value if the <a class="el" href="struct_xs_vector.html" title="A class that represents a vector of real numbers. ">XsVector</a> does not contain any values. <br /></td></tr>
<tr class="separator:afb1b4fbc07163a7b5fc52e795a2e0fa7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0832bbab634f57d9fcb1a5966ecbfb55"><td class="memItemLeft" align="right" valign="top"><a class="el" href="struct_xs_vector.html">XsVector</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a0832bbab634f57d9fcb1a5966ecbfb55">angularVelocityFromQuaternion</a> (const <a class="el" href="struct_xs_quaternion.html">XsQuaternion</a> &amp;quat, XsReal deltaT)</td></tr>
<tr class="memdesc:a0832bbab634f57d9fcb1a5966ecbfb55"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get an effective angular velocity from the quaternion, which must represent a delta angle.  <a href="#a0832bbab634f57d9fcb1a5966ecbfb55">More...</a><br /></td></tr>
<tr class="separator:a0832bbab634f57d9fcb1a5966ecbfb55"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a207eb80f92a0aed5139b0f81adbdfd5f"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a207eb80f92a0aed5139b0f81adbdfd5f"></a>
<a class="el" href="struct_xs_vector.html">XsVector</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a207eb80f92a0aed5139b0f81adbdfd5f">operator-</a> (const <a class="el" href="struct_xs_vector.html">XsVector</a> &amp;sub) const </td></tr>
<tr class="memdesc:a207eb80f92a0aed5139b0f81adbdfd5f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return <em>this</em> - <em>sub</em>. <br /></td></tr>
<tr class="separator:a207eb80f92a0aed5139b0f81adbdfd5f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a44cdf9e7f8470a813f2422ef71bed396"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a44cdf9e7f8470a813f2422ef71bed396"></a>
<a class="el" href="struct_xs_vector.html">XsVector</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a44cdf9e7f8470a813f2422ef71bed396">operator+</a> (const <a class="el" href="struct_xs_vector.html">XsVector</a> &amp;sub) const </td></tr>
<tr class="memdesc:a44cdf9e7f8470a813f2422ef71bed396"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return <em>this</em> + <em>sub</em>. <br /></td></tr>
<tr class="separator:a44cdf9e7f8470a813f2422ef71bed396"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4e65b3096a092a60a82832e7c9848e3d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4e65b3096a092a60a82832e7c9848e3d"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a4e65b3096a092a60a82832e7c9848e3d">operator==</a> (const <a class="el" href="struct_xs_vector.html">XsVector</a> &amp;other) const </td></tr>
<tr class="memdesc:a4e65b3096a092a60a82832e7c9848e3d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return true when the values in this vector are exactly (to the last bit) equal to <em>other</em>. <br /></td></tr>
<tr class="separator:a4e65b3096a092a60a82832e7c9848e3d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a51fc1c477411b33f97472165b73795d5"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a51fc1c477411b33f97472165b73795d5">compare</a> (const <a class="el" href="struct_xs_vector.html">XsVector</a> &amp;other, XsReal epsilon) const </td></tr>
<tr class="memdesc:a51fc1c477411b33f97472165b73795d5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return true when the values in this vector are equal within <em>epsilon</em>.  <a href="#a51fc1c477411b33f97472165b73795d5">More...</a><br /></td></tr>
<tr class="separator:a51fc1c477411b33f97472165b73795d5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac35c517ad69323e02be6fdfda2b9a97c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac35c517ad69323e02be6fdfda2b9a97c"></a>
std::vector&lt; XsReal &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#ac35c517ad69323e02be6fdfda2b9a97c">toVector</a> () const </td></tr>
<tr class="memdesc:ac35c517ad69323e02be6fdfda2b9a97c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the <a class="el" href="struct_xs_vector.html" title="A class that represents a vector of real numbers. ">XsVector</a> as a std::vector of XsReal. <br /></td></tr>
<tr class="separator:ac35c517ad69323e02be6fdfda2b9a97c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abd8dc1b38f92bf45a47112821fe8fb85"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abd8dc1b38f92bf45a47112821fe8fb85"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#abd8dc1b38f92bf45a47112821fe8fb85">zero</a> ()</td></tr>
<tr class="memdesc:abd8dc1b38f92bf45a47112821fe8fb85"><td class="mdescLeft">&#160;</td><td class="mdescRight">Fill the vector with zeroes. <br /></td></tr>
<tr class="separator:abd8dc1b38f92bf45a47112821fe8fb85"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7f024cfabfeb5a666b1a8c0faf8c7fef"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7f024cfabfeb5a666b1a8c0faf8c7fef"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a7f024cfabfeb5a666b1a8c0faf8c7fef">fill</a> (XsReal val)</td></tr>
<tr class="memdesc:a7f024cfabfeb5a666b1a8c0faf8c7fef"><td class="mdescLeft">&#160;</td><td class="mdescRight">Fill the vector with <em>val</em>. <br /></td></tr>
<tr class="separator:a7f024cfabfeb5a666b1a8c0faf8c7fef"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2338cc0778af57ef43a46d6ec7ce7d34"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a2338cc0778af57ef43a46d6ec7ce7d34">swap</a> (<a class="el" href="struct_xs_vector.html">XsVector</a> &amp;b)</td></tr>
<tr class="memdesc:a2338cc0778af57ef43a46d6ec7ce7d34"><td class="mdescLeft">&#160;</td><td class="mdescRight">Swap the contents of <em>b</em> with this.  <a href="#a2338cc0778af57ef43a46d6ec7ce7d34">More...</a><br /></td></tr>
<tr class="separator:a2338cc0778af57ef43a46d6ec7ce7d34"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3cbb4f97a4fc50381a2cbb4206197ca9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a3cbb4f97a4fc50381a2cbb4206197ca9">append</a> (<a class="el" href="struct_xs_vector.html">XsVector</a> const &amp;other)</td></tr>
<tr class="memdesc:a3cbb4f97a4fc50381a2cbb4206197ca9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Append <em>other</em> to this.  <a href="#a3cbb4f97a4fc50381a2cbb4206197ca9">More...</a><br /></td></tr>
<tr class="separator:a3cbb4f97a4fc50381a2cbb4206197ca9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abf7ea0e3e4f9b3b71e6b9969abcfad35"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abf7ea0e3e4f9b3b71e6b9969abcfad35"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#abf7ea0e3e4f9b3b71e6b9969abcfad35">clear</a> ()</td></tr>
<tr class="memdesc:abf7ea0e3e4f9b3b71e6b9969abcfad35"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clear the vector, making it size 0. <br /></td></tr>
<tr class="separator:abf7ea0e3e4f9b3b71e6b9969abcfad35"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afe85d8aef53e23ed96ebe570af78b793"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="afe85d8aef53e23ed96ebe570af78b793"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#afe85d8aef53e23ed96ebe570af78b793">reverse</a> ()</td></tr>
<tr class="memdesc:afe85d8aef53e23ed96ebe570af78b793"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reverse the values in the vector. <br /></td></tr>
<tr class="separator:afe85d8aef53e23ed96ebe570af78b793"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:afbb15145c7abdce44fed4aedb63b8b31"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="afbb15145c7abdce44fed4aedb63b8b31"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#afbb15145c7abdce44fed4aedb63b8b31">flags</a> ()</td></tr>
<tr class="memdesc:afbb15145c7abdce44fed4aedb63b8b31"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the data management flags of the vector. <br /></td></tr>
<tr class="separator:afbb15145c7abdce44fed4aedb63b8b31"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:aefc1e89b4045b52cf81c09cf6f6c5eb4"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aefc1e89b4045b52cf81c09cf6f6c5eb4"></a>
XsReal *const&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#aefc1e89b4045b52cf81c09cf6f6c5eb4">m_data</a></td></tr>
<tr class="memdesc:aefc1e89b4045b52cf81c09cf6f6c5eb4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Points to contained data buffer. <br /></td></tr>
<tr class="separator:aefc1e89b4045b52cf81c09cf6f6c5eb4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a302af367307b1da94f90af0408fe20a8"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a302af367307b1da94f90af0408fe20a8"></a>
const XsSize&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a302af367307b1da94f90af0408fe20a8">m_size</a></td></tr>
<tr class="memdesc:a302af367307b1da94f90af0408fe20a8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Size of contained data buffer in elements. <br /></td></tr>
<tr class="separator:a302af367307b1da94f90af0408fe20a8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a88814a1a56ec41bdb5a2a3152871a938"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a88814a1a56ec41bdb5a2a3152871a938"></a>
const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_vector.html#a88814a1a56ec41bdb5a2a3152871a938">m_flags</a></td></tr>
<tr class="memdesc:a88814a1a56ec41bdb5a2a3152871a938"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flags for data management. <br /></td></tr>
<tr class="separator:a88814a1a56ec41bdb5a2a3152871a938"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="related"></a>
Related Functions</h2></td></tr>
<tr><td class="ititle" colspan="2"><p>(Note that these are not member functions.) </p>
</td></tr>
<tr class="memitem:ga028d330e7bb01b01b7ac831c4fe47b71"><td class="memItemLeft" align="right" valign="top">
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga028d330e7bb01b01b7ac831c4fe47b71">XsVector_ref</a> (<a class="el" href="struct_xs_vector.html">XsVector</a> *, XsSize sz, XsReal *buffer, <a class="el" href="group__enums.html#ga85bc9120949890bf9df4572ee9a95be5">XsDataFlags</a> <a class="el" href="struct_xs_vector.html#afbb15145c7abdce44fed4aedb63b8b31">flags</a>)</td></tr>
<tr class="memdesc:ga028d330e7bb01b01b7ac831c4fe47b71"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize the XsVector to refer to the supplied buffer. <br /></td></tr>
<tr class="separator:ga028d330e7bb01b01b7ac831c4fe47b71"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gafc0f6ef88463c27c0ebd5a16eea4d3b6"><td class="memItemLeft" align="right" valign="top">
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#gafc0f6ef88463c27c0ebd5a16eea4d3b6">XsVector_construct</a> (<a class="el" href="struct_xs_vector.html">XsVector</a> *, XsSize sz, const XsReal *src)</td></tr>
<tr class="memdesc:gafc0f6ef88463c27c0ebd5a16eea4d3b6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize the XsVector using <em>sz</em> number of items from <em>src</em>. <br /></td></tr>
<tr class="separator:gafc0f6ef88463c27c0ebd5a16eea4d3b6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gafd92f0315fa77840940cd63b25612f52"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#gafd92f0315fa77840940cd63b25612f52">XsVector_assign</a> (<a class="el" href="struct_xs_vector.html">XsVector</a> *, XsSize sz, const XsReal *src)</td></tr>
<tr class="memdesc:gafd92f0315fa77840940cd63b25612f52"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize the <a class="el" href="struct_xs_vector.html" title="A class that represents a vector of real numbers. ">XsVector</a> using <em>sz</em> number of items from <em>src</em>.  <a href="group__cinterface.html#gafd92f0315fa77840940cd63b25612f52">More...</a><br /></td></tr>
<tr class="separator:gafd92f0315fa77840940cd63b25612f52"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf82281540cbb4bf44e38d8c9dd455f9e"><td class="memItemLeft" align="right" valign="top">
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#gaf82281540cbb4bf44e38d8c9dd455f9e">XsVector_destruct</a> (<a class="el" href="struct_xs_vector.html">XsVector</a> *)</td></tr>
<tr class="memdesc:gaf82281540cbb4bf44e38d8c9dd455f9e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Release and clear the contents of the vector. <br /></td></tr>
<tr class="separator:gaf82281540cbb4bf44e38d8c9dd455f9e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad5d7d3e5a0ba913181464ffda5cdda6c"><td class="memItemLeft" align="right" valign="top">
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#gad5d7d3e5a0ba913181464ffda5cdda6c">XsVector_copy</a> (<a class="el" href="struct_xs_vector.html">XsVector</a> *copy, <a class="el" href="struct_xs_vector.html">XsVector</a> const *src)</td></tr>
<tr class="memdesc:gad5d7d3e5a0ba913181464ffda5cdda6c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Copy the contents of the XsVector to <em>copy</em>. <br /></td></tr>
<tr class="separator:gad5d7d3e5a0ba913181464ffda5cdda6c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga732086e0854c6c1218ca3d1fddc7722c"><td class="memItemLeft" align="right" valign="top">
XsReal&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga732086e0854c6c1218ca3d1fddc7722c">XsVector_dotProduct</a> (const <a class="el" href="struct_xs_vector.html">XsVector</a> *a, const <a class="el" href="struct_xs_vector.html">XsVector</a> *b)</td></tr>
<tr class="memdesc:ga732086e0854c6c1218ca3d1fddc7722c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute and return the dot product of XsVectors <em>a</em> and <em>b</em>. <br /></td></tr>
<tr class="separator:ga732086e0854c6c1218ca3d1fddc7722c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga217ff6e4b3e3624cd6d93e7c4e7b61a3"><td class="memItemLeft" align="right" valign="top">XsReal&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga217ff6e4b3e3624cd6d93e7c4e7b61a3">XsVector_cartesianLength</a> (const <a class="el" href="struct_xs_vector.html">XsVector</a> *)</td></tr>
<tr class="memdesc:ga217ff6e4b3e3624cd6d93e7c4e7b61a3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute and return the cartesian length.  <a href="group__cinterface.html#ga217ff6e4b3e3624cd6d93e7c4e7b61a3">More...</a><br /></td></tr>
<tr class="separator:ga217ff6e4b3e3624cd6d93e7c4e7b61a3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga818a7f64ed8e20d0ee70067e31b489c0"><td class="memItemLeft" align="right" valign="top">
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga818a7f64ed8e20d0ee70067e31b489c0">XsVector_normalize</a> (<a class="el" href="struct_xs_vector.html">XsVector</a> *)</td></tr>
<tr class="memdesc:ga818a7f64ed8e20d0ee70067e31b489c0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Normalize the vector. <br /></td></tr>
<tr class="separator:ga818a7f64ed8e20d0ee70067e31b489c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga8c124e7419bf63e2d3e1682504ca8ff7"><td class="memItemLeft" align="right" valign="top">
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga8c124e7419bf63e2d3e1682504ca8ff7">XsVector_setZero</a> (<a class="el" href="struct_xs_vector.html">XsVector</a> *)</td></tr>
<tr class="memdesc:ga8c124e7419bf63e2d3e1682504ca8ff7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets all elements of the XsVector to 0. <br /></td></tr>
<tr class="separator:ga8c124e7419bf63e2d3e1682504ca8ff7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga54c1f360ee7560c392a7b3d09ba3d5d4"><td class="memItemLeft" align="right" valign="top">
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga54c1f360ee7560c392a7b3d09ba3d5d4">XsVector_fill</a> (struct <a class="el" href="struct_xs_vector.html">XsVector</a> *, XsReal <a class="el" href="struct_xs_vector.html#a79106a9af236f142bf3d32f387ddc373">value</a>)</td></tr>
<tr class="memdesc:ga54c1f360ee7560c392a7b3d09ba3d5d4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets all elements of the XsVector to <em>value</em>. <br /></td></tr>
<tr class="separator:ga54c1f360ee7560c392a7b3d09ba3d5d4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga9aa653c9dadd824d94c9a5ba32ce6b15"><td class="memItemLeft" align="right" valign="top">
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga9aa653c9dadd824d94c9a5ba32ce6b15">XsVector_empty</a> (const <a class="el" href="struct_xs_vector.html">XsVector</a> *)</td></tr>
<tr class="memdesc:ga9aa653c9dadd824d94c9a5ba32ce6b15"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a non-zero value if the <a class="el" href="struct_xs_vector.html" title="A class that represents a vector of real numbers. ">XsVector</a> does not contain any values. <br /></td></tr>
<tr class="separator:ga9aa653c9dadd824d94c9a5ba32ce6b15"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gadf11db4e898c308aee2929a1f63582c4"><td class="memItemLeft" align="right" valign="top">
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#gadf11db4e898c308aee2929a1f63582c4">XsVector_multiplyScalar</a> (const <a class="el" href="struct_xs_vector.html">XsVector</a> *, XsReal scalar, <a class="el" href="struct_xs_vector.html">XsVector</a> *dest)</td></tr>
<tr class="memdesc:gadf11db4e898c308aee2929a1f63582c4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Multiplies all values in this <a class="el" href="struct_xs_vector.html" title="A class that represents a vector of real numbers. ">XsVector</a> by <em>scalar</em> and puts the result in <a class="el" href="struct_xs_vector.html" title="A class that represents a vector of real numbers. ">XsVector</a> <em>dest</em>. <br /></td></tr>
<tr class="separator:gadf11db4e898c308aee2929a1f63582c4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga8c6ac21c4bbc663e10723e982150e1b7"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga8c6ac21c4bbc663e10723e982150e1b7">XsVector_angularVelocityFromQuaternion</a> (<a class="el" href="struct_xs_vector.html">XsVector</a> *, XsReal deltaT, const <a class="el" href="struct_xs_quaternion.html">XsQuaternion</a> *quat)</td></tr>
<tr class="memdesc:ga8c6ac21c4bbc663e10723e982150e1b7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get an effective angular velocity from the quaternion, which must represent a delta angle.  <a href="group__cinterface.html#ga8c6ac21c4bbc663e10723e982150e1b7">More...</a><br /></td></tr>
<tr class="separator:ga8c6ac21c4bbc663e10723e982150e1b7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7097bb62e03b0dd0bf57efcb2fa54e7e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga7097bb62e03b0dd0bf57efcb2fa54e7e">XsVector_swap</a> (<a class="el" href="struct_xs_vector.html">XsVector</a> *a, <a class="el" href="struct_xs_vector.html">XsVector</a> *b)</td></tr>
<tr class="memdesc:ga7097bb62e03b0dd0bf57efcb2fa54e7e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Swap the contents of <em>a</em> and <em>b</em>.  <a href="group__cinterface.html#ga7097bb62e03b0dd0bf57efcb2fa54e7e">More...</a><br /></td></tr>
<tr class="separator:ga7097bb62e03b0dd0bf57efcb2fa54e7e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga5ff1df86948c024ea56939838641a05e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga5ff1df86948c024ea56939838641a05e">XsVector_equal</a> (const struct <a class="el" href="struct_xs_vector.html">XsVector</a> *a, const struct <a class="el" href="struct_xs_vector.html">XsVector</a> *b)</td></tr>
<tr class="memdesc:ga5ff1df86948c024ea56939838641a05e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns non-zero when the two vectors are identical.  <a href="group__cinterface.html#ga5ff1df86948c024ea56939838641a05e">More...</a><br /></td></tr>
<tr class="separator:ga5ff1df86948c024ea56939838641a05e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga0a1e64d3b81c43310b8daefefc7cf5dd"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga0a1e64d3b81c43310b8daefefc7cf5dd">XsVector_compare</a> (const struct <a class="el" href="struct_xs_vector.html">XsVector</a> *, const struct <a class="el" href="struct_xs_vector.html">XsVector</a> *thatPtr, XsReal epsilon)</td></tr>
<tr class="memdesc:ga0a1e64d3b81c43310b8daefefc7cf5dd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns non-zero if the two vectors are equal within <em>epsilon</em>.  <a href="group__cinterface.html#ga0a1e64d3b81c43310b8daefefc7cf5dd">More...</a><br /></td></tr>
<tr class="separator:ga0a1e64d3b81c43310b8daefefc7cf5dd"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>A class that represents a vector of real numbers. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a1940a6cfb6a3da48b97a655e81b3152a"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">XsVector::XsVector </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="struct_xs_quaternion.html">XsQuaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>quat</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">XsReal&#160;</td>
          <td class="paramname"><em>deltaT</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">explicit</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get an effective angular velocity from the quaternion, which must represent a delta angle. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">deltaT</td><td>The length of the time interval over which <em>quat</em> was integrated in seconds </td></tr>
    <tr><td class="paramname">quat</td><td>The orientation increment to convert to an angular velocity </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A vector containing the effective angular velocity in radians around each axis. </dd></dl>

</div>
</div>
<a class="anchor" id="a08ed04b76bcceebc3c2316cf8910cf39"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">XsVector::~XsVector </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Release and clear the contents of the vector. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a0832bbab634f57d9fcb1a5966ecbfb55"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="struct_xs_vector.html">XsVector</a>&amp; XsVector::angularVelocityFromQuaternion </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="struct_xs_quaternion.html">XsQuaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>quat</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">XsReal&#160;</td>
          <td class="paramname"><em>deltaT</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get an effective angular velocity from the quaternion, which must represent a delta angle. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">deltaT</td><td>The length of the time interval over which <em>quat</em> was integrated in seconds </td></tr>
    <tr><td class="paramname">quat</td><td>The orientation increment to convert to an angular velocity </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A vector containing the effective angular velocity in radians around each axis. </dd></dl>

</div>
</div>
<a class="anchor" id="a3cbb4f97a4fc50381a2cbb4206197ca9"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void XsVector::append </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct_xs_vector.html">XsVector</a> const &amp;&#160;</td>
          <td class="paramname"><em>other</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Append <em>other</em> to this. </p>
<p>Append the vector in <em>other</em> to the end of this vector </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">other</td><td>The vector to append </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a5beb327e40afab8412451c8273cb256c"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void XsVector::assign </td>
          <td>(</td>
          <td class="paramtype">XsSize&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const XsReal *&#160;</td>
          <td class="paramname"><em>src</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Initialize the <a class="el" href="struct_xs_vector.html" title="A class that represents a vector of real numbers. ">XsVector</a> using <em>sz</em> number of items from <em>src</em>. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sz</td><td>The desired size of the vector </td></tr>
    <tr><td class="paramname">src</td><td>0 or a pointer to a buffer containing <em>sz</em> items to copy into the XsVector </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a8d233a95a950bc1decf33fc05cc36438"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">XsReal XsVector::cartesianLength </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Compute and return the cartesian length. </p>
<dl class="section return"><dt>Returns</dt><dd>The cartesian length (square root of the dot product) of the vector </dd></dl>

</div>
</div>
<a class="anchor" id="a51fc1c477411b33f97472165b73795d5"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool XsVector::compare </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="struct_xs_vector.html">XsVector</a> &amp;&#160;</td>
          <td class="paramname"><em>other</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">XsReal&#160;</td>
          <td class="paramname"><em>epsilon</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Return true when the values in this vector are equal within <em>epsilon</em>. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">other</td><td>the vector to compare with </td></tr>
    <tr><td class="paramname">epsilon</td><td>the maximum difference between individual values </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if the vectors are equal within <em>epsilon</em> </dd></dl>

</div>
</div>
<a class="anchor" id="a71be6087010ff667bead275af69c2125"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void XsVector::normalize </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Normalize the vector. </p>

</div>
</div>
<a class="anchor" id="ac8917f40e072ad07e31c149986ea9a8d"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void XsVector::setSize </td>
          <td>(</td>
          <td class="paramtype">XsSize&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets the size of the <a class="el" href="struct_xs_vector.html" title="A class that represents a vector of real numbers. ">XsVector</a> to <em>sz</em> items. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sz</td><td>The desired size of the vector </td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="group__cinterface.html#gafd92f0315fa77840940cd63b25612f52" title="Initialize the XsVector using sz number of items from src. ">XsVector_assign</a> </dd></dl>

</div>
</div>
<a class="anchor" id="a2338cc0778af57ef43a46d6ec7ce7d34"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void XsVector::swap </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct_xs_vector.html">XsVector</a> &amp;&#160;</td>
          <td class="paramname"><em>b</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Swap the contents of <em>b</em> with this. </p>
<p>This function swaps the internal buffers so no actual data is moved around. For unmanaged data an elementwise swap is done, but only if the vectors are the same size. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">b</td><td>Object whose contents will be swapped with this </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->

<div class="tabs">&nbsp;</div>
<hr size="1" />
<address style="text-align: right;">
<small>Generated on Thu Jun 29 2017 for Xsens by <a href="http://www.doxygen.org/index.html">Doxygen</a> 1.8.11</small>
</address>
</body>
</html>
